VUHDO_MAY_DEBUFF_ANIM = true;

local VUHDO_DEBUFF_ICONS = { };
local sIsAnim, sIsTimer, sIsStacks, sIsName, sIsAliveTime, sIsFullDuration;

-- BURST CACHE ---------------------------------------------------

local floor = floor;
local GetTime = GetTime;
local pairs = pairs;
local twipe = table.wipe;
local _;

local VUHDO_GLOBAL = getfenv();

local VUHDO_getUnitButtons;
local VUHDO_getBarIconTimer
local VUHDO_getBarIconCounter
local VUHDO_getBarIconFrame
local VUHDO_getBarIcon
local VUHDO_getBarIconName

local VUHDO_CONFIG;
local sCuDeConfig;
local sMaxIcons;

function VUHDO_customDebuffIconsInitBurst()
	-- functions
	VUHDO_getUnitButtons = VUHDO_GLOBAL["VUHDO_getUnitButtons"];
	VUHDO_getBarIconTimer = VUHDO_GLOBAL["VUHDO_getBarIconTimer"];
	VUHDO_getBarIconCounter = VUHDO_GLOBAL["VUHDO_getBarIconCounter"];
	VUHDO_getBarIconFrame = VUHDO_GLOBAL["VUHDO_getBarIconFrame"];
	VUHDO_getBarIcon = VUHDO_GLOBAL["VUHDO_getBarIcon"];
	VUHDO_getBarIconName = VUHDO_GLOBAL["VUHDO_getBarIconName"];

	VUHDO_CONFIG = VUHDO_GLOBAL["VUHDO_CONFIG"];
	sCuDeConfig = VUHDO_CONFIG["CUSTOM_DEBUFF"];
	sMaxIcons = VUHDO_CONFIG["CUSTOM_DEBUFF"]["max_num"];
	sIsName = sCuDeConfig["isName"];
end

----------------------------------------------------

--
local tAliveTime;
local tDelta;
local tIconFrame;
local tCnt;
local tIconInfo;
local tExpiry, tRemain;
local tStacks;
local tCuDeStoConfig;
local tIconIndex;
local tIconButton;

local function VUHDO_animateDebuffIcon(aButton, someIconInfos, aNow)
	for tCnt = 1, sMaxIcons do
		tIconIndex = tCnt + 39;
		tIconInfo = someIconInfos[tCnt];
		if (tIconInfo ~= nil) then
			tCuDeStoConfig = sCuDeConfig["STORED_SETTINGS"][tIconInfo[3]];
			if (tCuDeStoConfig == nil) then
				sIsAnim = sCuDeConfig["animate"] and VUHDO_MAY_DEBUFF_ANIM;
				sIsTimer = sCuDeConfig["timer"];
				sIsStacks = sCuDeConfig["isStacks"];
				sIsAliveTime = false;
				sIsFullDuration = false;
			else
				sIsAnim = tCuDeStoConfig["animate"] and VUHDO_MAY_DEBUFF_ANIM;
				sIsTimer = tCuDeStoConfig["timer"];
				sIsStacks = tCuDeStoConfig["isStacks"];
				sIsAliveTime = tCuDeStoConfig["isAliveTime"];
				sIsFullDuration = tCuDeStoConfig["isFullDuration"];
			end

			if (sIsTimer) then
				tExpiry = tIconInfo[4];

				if (sIsAliveTime) then
					tAliveTime = aNow - (tIconInfo[2] or 0);
					if (tAliveTime < 99.5) then
						VUHDO_getBarIconTimer(aButton, tIconIndex):SetText(floor(tAliveTime + 0.5));
					else
						VUHDO_getBarIconTimer(aButton, tIconIndex):SetText(">>");
					end
				elseif (tExpiry ~= nil) then
					tRemain = tExpiry - aNow;
					if (tRemain >= 0 and (tRemain < 10 or sIsFullDuration)) then
						if (tRemain > 100) then
							VUHDO_getBarIconTimer(aButton, tIconIndex):SetText(">>");
						else
							VUHDO_getBarIconTimer(aButton, tIconIndex):SetText(floor(tRemain));
						end
					else
						VUHDO_getBarIconTimer(aButton, tIconIndex):SetText("");
					end
				end
			end

			tStacks = tIconInfo[5];
			if (sIsStacks and (tStacks or 0) > 1) then
				VUHDO_getBarIconCounter(aButton, tIconIndex):SetText(tStacks);
			else
				VUHDO_getBarIconCounter(aButton, tIconIndex):SetText("");
			end

			tIconFrame = VUHDO_getBarIconFrame(aButton, tIconIndex);
			tIconButton = VUHDO_getBarIconButton(aButton, tIconIndex);

			if (tIconInfo[2] < 0) then
				tTimestamp = aNow;
				VUHDO_getBarIcon(aButton, tIconIndex):SetTexture(tIconInfo[1]);
				if (sIsName) then
					VUHDO_getBarIconName(aButton, tIconIndex):SetText(tIconInfo[3]);
					VUHDO_getBarIconName(aButton, tIconIndex):SetAlpha(1);
				end
				tIconFrame:SetAlpha(1);

				if (sIsAnim) then
					VUHDO_setDebuffAnimation(1.2);
				end

			else
				tTimestamp = tIconInfo[2];
			end

			tAliveTime = aNow - tTimestamp; -- kein self-or!
			if (sIsAnim) then
				if (tAliveTime <= 0.4) then
					tIconButton:SetScale((1 + (tAliveTime * 2.5)));
				elseif (tAliveTime <= 0.6) then
					 -- Keep size
				elseif (tAliveTime <= 1.1) then
					tDelta = (tAliveTime - 0.6) * 2;
					tIconButton:SetScale((1 + (1 - tDelta)));
				end
			end

			if (sIsName and tAliveTime > 2) then
				VUHDO_getBarIconName(aButton, tIconIndex):SetAlpha(0);
			end
		end
	end
end



--
local tUnit, tDebuffInfos;
local tAllButtons, tButton;
local tNow;
local tCnt;
function VUHDO_updateAllDebuffIcons()
	tNow = GetTime();

	for tUnit, tDebuffInfos in pairs(VUHDO_DEBUFF_ICONS) do
		tAllButtons = VUHDO_getUnitButtons(tUnit);
		if (tAllButtons ~= nil) then
			for _, tButton in pairs(tAllButtons) do
				VUHDO_animateDebuffIcon(tButton, tDebuffInfos, tNow);
			end

			for tCnt = 1, sMaxIcons do
				if (tDebuffInfos[tCnt] ~= nil and tDebuffInfos[tCnt][2] < 0) then
					tDebuffInfos[tCnt][2] = tNow;
				end
			end
		end
	end
end



-- 1 = icon, 2 = timestamp, 3 = name, 4 = expiration time, 5 = stacks, 6 = Duration, 7 = Start time
local tCnt;
local tSlot;
local tOldest;
local tAllButtons, tButton, tFrame;
function VUHDO_addDebuffIcon(aUnit, anIcon, aName, anExpiry, aStacks, aDuration, anIsBuff)
	if (VUHDO_DEBUFF_ICONS[aUnit] == nil) then
		VUHDO_DEBUFF_ICONS[aUnit] = { };
	end

	tOldest = GetTime();
	tSlot = 1;
	for tCnt = 1, sMaxIcons do
		if (VUHDO_DEBUFF_ICONS[aUnit][tCnt] == nil) then
			tSlot = tCnt;
			break;
		elseif (VUHDO_DEBUFF_ICONS[aUnit][tCnt][2] > 0 and VUHDO_DEBUFF_ICONS[aUnit][tCnt][2] < tOldest) then
			tOldest = VUHDO_DEBUFF_ICONS[aUnit][tCnt][2];
			tSlot = tCnt;
		end
	end

	tAllButtons = VUHDO_getUnitButtons(aUnit);
	if (tAllButtons ~= nil) then
		for _, tButton in pairs(tAllButtons) do
			tFrame = VUHDO_getBarIconFrame(tButton, tSlot + 39);
			tFrame["debuffInfo"] = aName;
			tFrame["isBuff"] = anIsBuff;
		end
	end

	VUHDO_DEBUFF_ICONS[aUnit][tSlot] = { anIcon, -1, aName, anExpiry, aStacks, aDuration };
	VUHDO_updateHealthBarsFor(aUnit, VUHDO_UPDATE_RANGE);
end



--
local tCnt, tUnitDebuff;
function VUHDO_updateDebuffIcon(aUnit, anIcon, aName, anExpiry, aStacks, aDuration)
	if (VUHDO_DEBUFF_ICONS[aUnit] == nil) then
		VUHDO_DEBUFF_ICONS[aUnit] = { };
	end

	for tCnt = 1, sMaxIcons do
		if (VUHDO_DEBUFF_ICONS[aUnit][tCnt] ~= nil) then
			tUnitDebuff = VUHDO_DEBUFF_ICONS[aUnit][tCnt];
			if (tUnitDebuff[3] == aName) then
				tUnitDebuff[4] = anExpiry;
				tUnitDebuff[5] = aStacks;
				tUnitDebuff[6] = aDuration;
			end
		end
	end
end



--
local tAllButtons2, tCnt2, tButton2;
local tFrame;
function VUHDO_removeDebuffIcon(aUnit, aName)
	tAllButtons2 = VUHDO_getUnitButtons(aUnit);
	if (tAllButtons2 == nil) then
		return;
	end

	for tCnt2 = 1, sMaxIcons do
		if (VUHDO_DEBUFF_ICONS[aUnit][tCnt2] ~= nil and VUHDO_DEBUFF_ICONS[aUnit][tCnt2][3] == aName) then
			VUHDO_DEBUFF_ICONS[aUnit][tCnt2][2] = 1; -- ~= -1, lock icon to not be processed by onupdate
			for _, tButton2 in pairs(tAllButtons2) do
				tFrame = VUHDO_getBarIconFrame(tButton2, tCnt2 + 39);
				tFrame:SetAlpha(0);
				tFrame["debuffInfo"] = nil;
			end

			VUHDO_DEBUFF_ICONS[aUnit][tCnt2] = nil;
		end
	end
end



--
local tAllButtons3, tCnt3, tButton3;
local tFrame;
function VUHDO_removeAllDebuffIcons(aUnit)
	tAllButtons3 = VUHDO_getUnitButtons(aUnit);
	if (tAllButtons3 == nil) then
		return;
	end

	for _, tButton3 in pairs(tAllButtons3) do
		for tCnt3 = 40, 44 do
			tFrame = VUHDO_getBarIconFrame(tButton3, tCnt3);
			tFrame:SetAlpha(0);
			tFrame["debuffInfo"] = nil;
		end
	end

	if (VUHDO_DEBUFF_ICONS[aUnit] ~= nil) then
		twipe(VUHDO_DEBUFF_ICONS[aUnit]);
	end

	VUHDO_updateBouquetsForEvent(aUnit, 29);
end



--
local tDebuffInfo;
local tCnt;
local tNewest;
local tEmptyInfo = { };
local tCurrInfo;
function VUHDO_getLastestCustomDebuff(aUnit)
	tDebuffInfo = tEmptyInfo;
	tNewest = 0;

	for tCnt = 1, sMaxIcons do
	  tCurrInfo = (VUHDO_DEBUFF_ICONS[aUnit] or tEmptyInfo)[tCnt];
		if (tCurrInfo ~= nil) then
			if (tCurrInfo[2] > tNewest) then
				tDebuffInfo = tCurrInfo;
				tNewest = tDebuffInfo[2];
			end
		end
	end

	return tDebuffInfo[1], tDebuffInfo[4], tDebuffInfo[5], tDebuffInfo[6];
end
